/**
 * Library implementing a searchable string list.
 *
 **
 * $Id: strlist.c,v 1.1.1.1 2001/04/30 10:49:38 sd Exp $
 * $Source: /var/cvs/foo/src/lib/strlist.c,v $
 * Author: Soren
 */
#include "strlist.h"
#include <stdlib.h>
#include <stdio.h>

long str_count(struct strlist *l) {
        if (l)
		return 1+str_count(l->next);
	else
		return 0;
}

struct strlist *str_search(struct strlist *l, char *s) {
	struct strlist *t=l;

	while (t) {
		if (!strcmp(s, t->line))
			break;

		t=t->next;
	}

	return t;
}

struct strlist *str_add(struct strlist *l, char *s) {
	struct strlist *t=(struct strlist *)malloc(sizeof(struct strlist));

	strcpy(t->line,s);
	t->next=l;

	return t;
}

struct strlist *str_load(struct strlist *l, char *fn) {
	FILE *f;
	char buf[1024];

	f = fopen(fn, "r");

	if (!f)
		return l;

	while (fgetsnolfs(buf, 1024, f))
		l = str_add(l, buf);

	fclose(f);

	return l;
}

void str_close(struct strlist *l) {
	struct strlist *t;

	while (l) {
		t=l;
		l=l->next;
		free(t);
	}
}
