/*
 * Finds xdupe entries in a buffer and fills them onto a dupelist.
 *
 * Flower, <flower@tanesha.net>
 */

#include "stringtokenizer.h"
#include "strlist.h"
#include <string.h>
#include <stdio.h>

struct strlist * _xdupeline(char *buf, struct strlist *l);
struct strlist * xdupe(char *b, struct strlist *l);

struct strlist * _xdupeline(char *buf, struct strlist *l) {
  stringtokenizer st;
  char *t;

  st_initialize(&st, buf, " ");

  while (st_hasnext(&st)) {
    t = st_next(&st);

    if (!str_search(l, t))
      l = str_add(l, t);
  }

  st_finalize(&st);

  return l;
}


struct strlist * xdupe(char *b, struct strlist *l) {
  char *t, *s, *off;
  char *buf = strdup(b);

  s = t = buf;

  for (;;) {
    if ((*t == '\n') || (*t == '\r')) {
      *(t++) = 0;

      if ((off = strstr(s, "X-DUPE: ")))
	l = _xdupeline(off + 8, l);

      s = t;
    }
    if (*t == 0) {

      if ((off = strstr(s, "X-DUPE: ")))
	l = _xdupeline(off + 8, l);

      break;
    }

    t++;
  }

  return l;
}

/*
 * test of functionality.
 *

int main(int argc, char *argv) {
  struct strlist *l = 0, *tmp;
  char *buf = "X-DUPE: hello.123 hi.mom
X-DUPE: hello.143 hello.123 check
";

  l = xdupe(buf, l);

  for (tmp = l; tmp; tmp = tmp->next)
    printf("tmp = %s\n", tmp->line);

}

*/



